HDU-1059 Dividing (多重背包 二进制优化+剪枝)

来源:互联网 发布:科学与认识的关系 知乎 编辑:程序博客网 时间:2024/05/23 13:28

Dividing

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 27707    Accepted Submission(s): 7961


Problem Description
Marsha and Bill own a collection of marbles. They want to split the collection among themselves so that both receive an equal share of the marbles. This would be easy if all the marbles had the same value, because then they could just split the collection in half. But unfortunately, some of the marbles are larger, or more beautiful than others. So, Marsha and Bill start by assigning a value, a natural number between one and six, to each marble. Now they want to divide the marbles so that each of them gets the same total value. 
Unfortunately, they realize that it might be impossible to divide the marbles in this way (even if the total value of all marbles is even). For example, if there are one marble of value 1, one of value 3 and two of value 4, then they cannot be split into sets of equal value. So, they ask you to write a program that checks whether there is a fair partition of the marbles.
 

Input
Each line in the input describes one collection of marbles to be divided. The lines consist of six non-negative integers n1, n2, ..., n6, where ni is the number of marbles of value i. So, the example from above would be described by the input-line ``1 0 1 2 0 0''. The maximum total number of marbles will be 20000. 

The last line of the input file will be ``0 0 0 0 0 0''; do not process this line.
 

Output
For each colletcion, output ``Collection #k:'', where k is the number of the test case, and then either ``Can be divided.'' or ``Can't be divided.''. 

Output a blank line after each test case.
 

Sample Input
1 0 1 2 0 01 0 0 0 1 10 0 0 0 0 0
 

Sample Output
Collection #1:Can't be divided.Collection #2:Can be divided.
 

#include <bits/stdc++.h>using namespace std;int dp[120005], num[7];int main(){int casenum = 1;while(scanf("%d %d %d %d %d %d", &num[1], &num[2], &num[3], &num[4], &num[5], &num[6]) != EOF){if(num[1] == 0 && num[2] == 0 && num[3] == 0 && num[4] == 0 && num[5] == 0 && num[6] == 0) return 0;int tot = 0;for(int i = 1; i <= 6; ++i){tot += i * num[i];}if(tot % 2 == 1){printf("Collection #%d:\nCan't be divided.\n\n", casenum++);              continue;  }tot /= 2;memset(dp, 0, (tot + 1) * sizeof(dp[0]));int tot1 = 0;for(int i = 1; i <= 6; ++i){tot1 += num[i] * i;int cnt = 0, cur = 1, v;while(cnt + cur <= num[i]){v = cur * i;for(int j = min(tot, tot1); j >= v; --j){if(dp[j] == j){break;}dp[j] = max(dp[j], dp[j - v] + v);}cnt += cur;cur *= 2;}if(num[i] > cnt){v = i * (num[i] - cnt);for(int j = min(tot, tot1); j >= v; --j){if(dp[j] == j){break;}dp[j] = max(dp[j], dp[j - v] + v);}}}if(dp[tot] == tot){printf("Collection #%d:\nCan be divided.\n\n", casenum++); }else{printf("Collection #%d:\nCan't be divided.\n\n", casenum++);}}}/*题意:1.2.3.4.5.6的硬币各不超过20000个,问是否可以分为相等的两份。思路:和0/1背包里面的分硬币题差不多,只不过这里分组背包需要用二进制优化一下复杂度,同时剪枝一下,dp[j] == j时可以停止更新了,因为是从硬币1到6更新的,小的硬币都可以填满j了,那么更小的一定可以填满。*/


阅读全文
0 0